#include "S4WiFiSetup.h"
#include "NetworkParameters.h"
#include <WiFly.h>
#include <SPI.h>
#include "Arduino.h"
#include "SoftwareSerial.h"
#include "Wire.h"

S4WiFiSetup S4WiFiSetup;
NetworkParameters nParameters;



void setup() 
{
  Serial.begin(9600);
  Serial.println("Configuring WiFly Paramaters (this may ~60 seconds)...");
  S4WiFiSetup.begin();
  delay(100);
  S4WiFiSetup.setDCHP(nParameters.getValue(nParameters.UseDHCP).c_str()); 
  delay(100);
  S4WiFiSetup.setIpGateway(nParameters.getValue(nParameters.GatewayIP).c_str()); // sets gateway ip addresss
  delay(100);
  S4WiFiSetup.setLocalPort(nParameters.getValue(nParameters.ServerPort).c_str()); // sets port of that device connects too
  delay(100);
  S4WiFiSetup.setWlanAuth(nParameters.getValue(nParameters.WLanAuth).c_str()); // sets to WEP-128 key
  delay(100);
  S4WiFiSetup.setDataRate(nParameters.getValue(nParameters.DataRate).c_str()); // lowest data rate 1 M/sS for max range
  delay(100);
  S4WiFiSetup.setDeviceName(nParameters.getValue(nParameters.DeviceName).c_str()); // device ID
  delay(100);
  S4WiFiSetup.setRouterKey(nParameters.getValue(nParameters.Wep_key).c_str()); // WEP key
  delay(100);
  S4WiFiSetup.setIpAddress(nParameters.getValue(nParameters.DeviceIPAddress).c_str()); // ip address of devices
  delay(100);
  S4WiFiSetup.setHostAdderss(nParameters.getValue(nParameters.ServerIP).c_str());// ip of computer that recives TCP or UDP connection
  delay(100);
  S4WiFiSetup.setHostPort(nParameters.getValue(nParameters.HostPort).c_str());
  delay(200);
  S4WiFiSetup.setSSID(nParameters.getValue(nParameters.SSID).c_str());
  delay(1000);
  S4WiFiSetup.setBrodcastAddress(nParameters.getValue(nParameters.ServerIP).c_str()); // ip of computer that recives brodcast message
  delay(1000);
  S4WiFiSetup.setBordcastInterval(nParameters.getValue(nParameters.BroadcastInterval).c_str()); // brodcast every 2 seconda minumum
  delay(1000);
  S4WiFiSetup.setExternalAntenna(nParameters.getValue(nParameters.UseExternalAntenna).c_str()); //external antennae 1, chip antenna 0
  delay(200);
  S4WiFiSetup.setFlushSize(nParameters.getValue(nParameters.FlushSize).c_str()); // largest size for best TCP so 1420bytes at 9600 buad
  delay(100);
  S4WiFiSetup.setProto(nParameters.getValue(nParameters.Protocol).c_str()); //TCP proto 2; UDP proto 1
  delay(100);
  S4WiFiSetup.setJoin("1"); //Auto Join
  delay(100);
  S4WiFiSetup.setChannel(nParameters.getValue(nParameters.Channel).c_str()); // scans for the channel if 0; else 1-13 fixed
  S4WiFiSetup.save();
  delay(200);
  Serial.println("WiFly Paramaters Configured. Entering Command Mode.");

}

void loop()
{
  while(SpiSerial.available() > 0) {

#if ARDUINO >= 100
    Serial.write(SpiSerial.read());
#else
    Serial.print(SpiSerial.read(), BYTE);
#endif
  }
  
  if(Serial.available()) { // Outgoing data
#if ARDUINO >= 100  
    SpiSerial.write(Serial.read());
#else
    SpiSerial.print(Serial.read(), BYTE);
#endif
  }
}

